{ 2004-01-17 programmeerimisvistluse edasijudnute 1. lesande lahendus    }
{ lesanne: JADA                                                            }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'JADA.SIS';                                    { sisendfaili nimi }
   valf = 'JADA.VAL';                                   { vljundfaili nimi }
   maxm = 8000000;                          { rohkem 32M mlu sisse ei mahu }

var
   m, a, b, x : longint;                                     { sisendandmed }
   e : array [0..maxm] of longint;     { e[x] on x esimese esinemise indeks }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   i : longint;                                 { abimuutuja korduste jaoks }

begin
   assign(f, sisf); reset(f);
   readln(f, m, a, b, x);
   close(f);

   { le mlupiiride joosta pole ilus, parem anname kohe veateate }
   if m > maxm then begin
      writeln('Mlu otsas');
      halt(1);
   end;

   { algvrtustame esinemiste loendurid }
   for i := 0 to m do
      e[i] := -1;

   { kontrollime jrjest jada elemente }
   i := 0;
   while true do begin
      { kui x on varem esinenud, ongi periood kes }
      if e[x] <> -1 then
         break;
      { mrgime x esinemise }
      e[x] := i;
      { leiame jrgmise elemendi }
      i := i + 1;
      x := (sqr(int64(x)) mod m * a + b) mod m;
   end;

   assign(f, valf); rewrite(f);
   writeln(f, i - e[x]);
   close(f);
end.
