{ 2004-01-17 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: RNDKAUPMEES                                                    }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32, TPC 6.0                                     }

{ Ahne algoritm: igal sammul lheb lhimasse veel klastamata linna.        }
{ Leitud lahendust pame parandada jrjestikuste linnade vahetamisega.     }

const
   sisf = 'KAUP.SIS';                                    { sisendfaili nimi }
   valf = 'KAUP.VAL';                                   { vljundfaili nimi }
   maxn = 100;                                    { maksimaalne linnade arv }

var
   n : integer;                                               { linnade arv }
   x, y : array [1..maxn] of real;                   { linnade koordinaadid }
   d : array [1..maxn, 1..maxn] of real;       { linnade vahelised kaugused }
   p : array [1..maxn] of integer;             { linnade lbimise jrjekord }
   v : array [1..maxn] of boolean;                { kas linn on veel "vaba" }
   r : real;                                            { leitud tee pikkus }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   i, j, k : integer;                          { abimuutujad korduste jaoks }
   w : boolean;                            { kas leidsime parandusvimaluse }

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, x[i], y[i]);
   close(f);

   { arvutame kikide linnade omavahelised kaugused }
   for i := 1 to n do
      for j := i + 1 to n do begin
         d[i, j] := sqrt(sqr(x[i] - x[j]) + sqr(y[i] - y[j]));
         d[j, i] := d[i, j];
      end;

   { alguses on kik linnad klastamata }
   for i := 1 to n do
      v[i] := true;

   { alustame esimesest linnast ja edasi vtame igal sammul lhima vaba }
   p[1] := 1; v[1] := false;
   for i := 2 to n do begin
      k := 0;
      for j := 1 to n do
         if v[j] then
            if k = 0 then
               k := j
            else if d[p[i - 1], k] > d[p[i - 1], j] then
               k := j;
      p[i] := k; v[k] := false;
   end;

   { 2 vi 3 linna korral pole jrjekorral thtsust }
   if n > 3 then
      repeat
         w := false;                                  { seni parandusi pole }
         for i := 2 to n - 1 do begin
            if i = n - 1 then j := 1 else j := i + 2;
            { kas teekond (i-1)-(i+1)-i-(i+2) on lhem kui (i-1)-i-(i+1)-(i+2)? }
            if d[p[i - 1], p[i + 1]] + d[p[i], p[j]] <
                  d[p[i - 1], p[i]] + d[p[i + 1], p[j]] then begin
               k := p[i]; p[i] := p[i + 1]; p[i + 1] := k;
               w := true;                              { leidsime paranduse }
            end;
         end;
      until not w;

   { arvutame teepikkuse }
   r := 0;
   for i := 1 to n do
      r := r + d[p[i], p[i mod n + 1]];

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, r);
   for i := 1 to n do
      write(f, p[i], ' ');
   writeln(f, p[1]);
   close(f);
end.
