{ 2004-01-17 programmeerimisvistluse edasijudnute 2. lesande tester      }
{ lesanne: RNDKAUPMEES                                                    }
{ Autor: Ahto Truu                                                          }

{$I+}

const
   maxn = 100;

var
   f : text;
   n : integer;
   x, y : array [1..maxn] of double;
   p, pp : double;
   k : array [0..maxn] of integer;
   i, j : integer;

function kaugus(i1, i2 : integer) : double;
begin
   kaugus := sqrt(sqr(x[i1] - x[i2]) + sqr(y[i1] - y[i2]));
end;

begin
   if paramcount <> 2 then begin
      writeln('Sntaks on: ', paramstr(0), ' sisendfail vljundfail');
      halt(1);
   end;

   { loeme sisendandmed }
   assign(f, paramstr(1)); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, x[i], y[i]);
   close(f);

   { loeme vljundandmed }
   assign(f, paramstr(2)); reset(f);
   read(f, p);
   if not seekeoln(f) then
      writeln('Liigsed smbolid rea lpus');
   readln(f);
   for i := 0 to n do begin
      if seekeoln(f) then begin
         writeln('Enneaegne rea lpp');
         halt(1);
      end;
      read(f, k[i]);
      if (k[i] < 1) or (k[i] > n) then begin
         writeln('Lubamatu linn ', k[i]);
         halt(1);
      end;
   end;
   if not seekeoln(f) then
      writeln('Liigsed smbolid rea lpus');
   readln(f);
   if not eof(f) then
      writeln('Liigsed read faili lpus');
   close(f);

   { kontrollime koosklalisust }
   if k[0] <> 1 then begin
      writeln('Lubamatu alguspunkt ',  k[0]);
      halt(1);
   end;
   if k[n] <> 1 then begin
      writeln('Lubamatu lpp-punkt ',  k[n]);
      halt(1);
   end;
   for i := 1 to n do
      for j := i + 1 to n do
         if k[i] = k[j] then begin
            writeln('Korduv linn ', k[i]);
            halt(1);
         end;
   pp := 0;
   for i := 1 to n do
      pp := pp + kaugus(k[i - 1], k[i]);
   if abs(p - pp) > 1e-5 * pp then begin
      writeln('Vale pikkus ', p, ', peaks olema ', pp);
      halt(1);
   end;

   { muidu OK }
   writeln('Korras: ', pp);
end.
