/* 2004-01-17 programmeerimisvistluse algajate 1. lesande lahendus       */
/* lesanne: NMEA                                                          */
/* Autor: Heno Ivanov                                                      */
/* Testitud: GCC 3.2 / Linux, GCC 3.2 / MinGW                              */

#include <stdio.h>
#include <string.h>

#define ei(x) fprintf(x,"EI\n")
#define jah(x) fprintf(x,"JAH\n")

int main() {
	FILE *fi,*fo;
	int j,i,n;
	char sbuf[1000];
	char ck[4];
	int cksum;
	int l;

	if ((fi = fopen("NMEA.SIS","r")) == NULL) 
		return 1;
	if ((fo = fopen("NMEA.VAL","w")) == NULL)
		return 1;

	fscanf(fi,"%d\n",&n);
	for (i=0;i<n;i++) {
		fgets(sbuf,100,fi);
		l = strlen(sbuf) - 1;
		if (l<4)  { ei(fo); continue; }
		if ((sbuf[0] != '$') || (sbuf[l-3] != '*')) { ei(fo); continue; } 

		cksum = 0;
		for (j=1;j<l-3;j++) 
			cksum ^= sbuf[j] & 0xff;

		sprintf(ck,"%02X",(int)cksum);
		/* printf("cksum = %s\n",ck); */
		if ((ck[0] != sbuf[l-2]) || (ck[1] != sbuf[l-1]))  
			ei(fo);
		else
			jah(fo);
		
	
	}

	fclose(fo);
	fclose(fi);

	return 0;
}
