{ 2004-01-17 programmeerimisvistluse algajate 1. lesande lahendus         }
{ lesanne: NMEA                                                            }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32, TPC 6.0                                     }

const
   sisf = 'NMEA.SIS';                                    { sisendfaili nimi }
   valf = 'NMEA.VAL';                                   { vljundfaili nimi }
   hex : string = '0123456789ABCDEF';                 { 16-ssteemi numbrid }

{ kontrollib snumi korrektsust }
function ok(s : string) : boolean;
var x, i : integer;
begin
   if length(s) < 4 then
      ok := false
   else begin
      x := 0;
      for i := 2 to length(s) - 3 do
         x := x xor ord(s[i]);
      ok := (s[1] = '$') and
         (s[length(s) - 2] = '*') and
         (s[length(s) - 1] = hex[x div 16 + 1]) and
         (s[length(s)] = hex[x mod 16 + 1]);
   end;
end;

var
   n : integer;                                              { snumite arv }
   fsis, fval : text;                { failimuutujad sisendi/vljundi jaoks }
   s : string;                                              { jooksev snum }
   i : integer;                                  { abimuutuja korduse jaoks }
begin
   { loeme sisendandmed ja ttleme kigult }
   assign(fsis, sisf); reset(fsis);
   assign(fval, valf); rewrite(fval);
   readln(fsis, n);
   for i := 1 to n do begin
      readln(fsis, s);
      if ok(s) then
         writeln(fval, 'JAH')
      else
         writeln(fval, 'EI');
   end;
   close(fsis);
   close(fval);
end.
