{ 2004-01-17 programmeerimisvistluse algajate 2. lesande lahendus         }
{ lesanne: PUHKEPEVAD                                                     }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32, TPC 6.0                                     }

const
   sisf = 'PUH.SIS';                                     { sisendfaili nimi }
   valf = 'PUH.VAL';                                    { vljundfaili nimi }

{ leiab pevade arvu antud aastas }
function paevi(a : integer) : integer;
begin
   if a mod 400 = 0 then
      paevi := 366                                              { liigaasta }
   else if a mod 100 = 0 then
      paevi := 365                                              { lihtaasta }
   else if a mod 4 = 0 then
      paevi := 366                                              { liigaasta }
   else
      paevi := 365;                                             { lihtaasta }
end;

{ leiab antud aasta 1. jaanuari ndalapaeva: 0..6 = E..P }
function algus(a : integer) : integer;
var p, i : integer;
begin
   { 01.01.1900 oli esmaspev }
   p := 0;
   { hilisemate aastate korral liidame eelmise aasta pevade arvu }
   for i := 1900 to a - 1 do
      p := p + paevi(i) mod 7;
   { ndalapeva nitab 7ga jagamise jk }
   algus := p mod 7;
end;

{ loendab puhkepevad (L, P) antud aastas }
function puhke(a : integer) : integer;
var p, i, i1, i2 : integer;
begin
   i1 := algus(a); i2 := i1 + paevi(a) - 1;
   p := 0;
   for i := i1 to i2 do
      if (i mod 7 = 5) or (i mod 7 = 6) then
         p := p + 1;
   puhke := p;
end;

var
   a : integer;                                               { aastanumber }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }

begin
   assign(f, sisf); reset(f);
   readln(f, a);
   close(f);

   assign(f, valf); rewrite(f);
   writeln(f, puhke(a));
   close(f);
end.
