{ 2003-11-08 programmeerimisvistluse algajate 3. lesande lahendus         }
{ lesanne: TABEL                                                           }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32, TPC 6.0                                     }

const
   sisf = 'TBL.SIS';                                     { sisendfaili nimi }
   valf = 'TBL.VAL';                                    { vljundfaili nimi }
   maxr = 100;                                     { maksimaalne ridade arv }
   maxv = 100;                                   { maksimaalne veergude arv }
   kust = '*';                                    { kustunud elemendi this }

type
   elem = record                                           { tabeli element }
      k : boolean;                                        { kas on kustunud }
      v : integer;                                  { vrtus, kui on teada }
   end;

{ loeb failist elemendi vrtuse }
procedure loe_elem(var f : text; var e : elem);
var c : char; s : string; u : integer;
begin
   { jtame thikud vahele }
   c := ' ';
   while c = ' ' do
      read(f, c);
   { loeme elemendi }
   s := '';
   while c <> ' ' do begin
      s := s + c;
      if eoln(f) then
         c := ' '
      else
         read(f, c);
   end;
   { salvestame elemendi }
   e.k := (s = kust);
   if not e.k then
      val(s, e.v, u);
end;

var
   r, v : integer;                                          { tabeli suurus }
   a : array [1..maxr, 1..maxv] of elem;                 { tabeli elemendid }
   kr : array [1..maxr] of integer;          { kustunute arvud ridade kaupa }
   kv : array [1..maxv] of integer;        { kustunute arvud veergude kaupa }
   f : text;                          { failimuutuja sisendi-vljundi jaoks }
   i, j : integer;                             { abimuutujad korduste jaoks }
   x : longint;
   lopp : boolean;

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, r, v);
   for i := 1 to r do begin
      for j := 1 to v do
         loe_elem(f, a[i, j]);
      readln(f);
   end;
   close(f);

   { teeme statistika ridade kaupa }
   for i := 1 to r do begin
      kr[i] := 0;
      for j := 1 to v do
         if a[i, j].k then
            kr[i] := kr[i] + 1;
   end;
   { teeme statistika veergude kaupa }
   for j := 1 to v do begin
      kv[j] := 0;
      for i := 1 to r do
         if a[i, j].k then
            kv[j] := kv[j] + 1;
   end;

   { lahendame lesande }
   repeat
      lopp := true;
      { otsime rea tiendamise vimalust }
      for i := 1 to r do
         if kr[i] = 1 then begin
            { kui ainult ks kustunud, saame selle taastada }
            x := 0;
            for j := 1 to v do
               if not a[i, j].k then
                  x := x + a[i, j].v;
            if not a[i, v].k then
               x := -x + 2 * a[i, v].v;
            for j := 1 to v do
               if a[i, j].k then begin
                  a[i, j].k := false;
                  a[i, j].v := x;
                  kr[i] := kr[i] - 1;
                  kv[j] := kv[j] - 1;
                  lopp := false;
               end;
         end;
      { otsime veeru tiendamise vimalust }
      for j := 1 to v do
         if kv[j] = 1 then begin
            { kui ainult ks kustunud, saame selle taastada }
            x := 0;
            for i := 1 to r do
               if not a[i, j].k then
                  x := x + a[i, j].v;
            if not a[r, j].k then
               x := -x + 2 * a[r, j].v;
            for i := 1 to r do
               if a[i, j].k then begin
                  a[i, j].k := false;
                  a[i, j].v := x;
                  kr[i] := kr[i] - 1;
                  kv[j] := kv[j] - 1;
                  lopp := false;
               end;
         end;
   until lopp;                         { lpetame, kui enam midagi ei muutu }

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   for i := 1 to r do begin
      for j := 1 to v do begin
         if a[i, j].k then
            write(f, kust)
         else
            write(f, a[i, j].v);
         if j < v then
            write(f, ' ')
         else
            writeln(f);
      end;
   end;
   close(f);
end.
