{ 2004-01-17 programmeerimisvistluse edasijudnute 2. lesande lahendus    }
{ lesanne: RNDKAUPMEES                                                    }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32, TPC 6.0                                     }

{ Eriti naiivne lahendus: lbib kik linnad numbrite jrjekorras.           }

const
   sisf = 'KAUP.SIS';                                    { sisendfaili nimi }
   valf = 'KAUP.VAL';                                   { vljundfaili nimi }
   maxn = 100;                                    { maksimaalne linnade arv }

var
   n : integer;                                               { linnade arv }
   x, y : array [1..maxn] of real;                   { linnade koordinaadid }
   r : real;                                            { leitud tee pikkus }
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   i : integer;                                 { abimuutuja korduste jaoks }

{ leiab kahe linna vahelise kauguse }
function kaugus(i1, i2 : integer) : real;
begin
   kaugus := sqrt(sqr(x[i1] - x[i2]) + sqr(y[i1] - y[i2]));
end;

begin
   { loeme sisendandmed }
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      readln(f, x[i], y[i]);
   close(f);

   { arvutame teepikkuse }
   r := 0;
   for i := 1 to n do
      r := r + kaugus(i, i mod n + 1);

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, r);
   for i := 1 to n do
      write(f, i, ' ');
   writeln(f, 1);
   close(f);
end.
