#! /usr/bin/python
# encoding: Latin-1

# 2004-01-17 programmeerimisvistluse algajate 2. lesande lahendus
# lesanne: PUHKEPEVAD
# Autor: Andres Soolo
# Testitud: Python 2.3.3 / Win32

# Funktsioon year_length leiab antud numbriga aasta pikkuse pevades
def year_length (year):
    if   (year % 400) == 0: return 366
    elif (year % 100) == 0: return 365
    elif (year % 4) == 0:   return 366
    else:                   return 365

# Loeme failist sisendandmed
infile = open('PUH.SIS', 'r')
A = int(infile.readline())
infile.close()

# Me teame, et 1. jaanuar 1900 oli esmaspev, mida me kodeerime nulliga.
# Leiame nd A. aasta 1. jaanuari ndalapeva.
day_of_week = 0
for i in range(1900, A):
    day_of_week = (day_of_week + year_length(i)) % 7

# Nd lihtsalt itereerime le aastapevade.
# (Lihtsama viisi leidmine oleks vimalik, kuid tarbetult keerukas.)
weekend_days = 0
for i in range(year_length(A)):
    if (day_of_week + i) % 7 in (5, 6):
        weekend_days = weekend_days + 1

# Lpuks vljastame resultaadi:
outfile = open('PUH.VAL', 'w')
outfile.write('%i\n' % weekend_days)
outfile.close()
