#! /usr/bin/python
# encoding: Latin-1

# 2004-01-17 programmeerimisvistluse algajate 3. lesande lahendus
# lesanne: TABEL
# Autor: Andres Soolo
# Testitud: Python 2.3.3 / Win32

# Loeme sisendandmed
infile = open('TBL.SIS', 'r')
R, V = [int(word) for word in infile.readline().split()]
table = []
for r in range(R):
    assert len(table) == r
    row_data = infile.readline().split()
    assert len(row_data) == V
    for i in range(len(row_data)):
        if row_data[i] != '*':
            row_data[i] = int(row_data[i])
    table.append(row_data)
infile.close()

# Nd itereerime le tabeli, kuni enam tiendusi teha ei saa
modified = True
while modified:
    modified = False
    # Kigepealt vaatleme ridu
    for r in range(R):
        stars = 0
        last_star = None
        for v in range(V):
            if table[r][v] == '*':
                stars = stars + 1
                last_star = v
        if stars == 1: # ksainus trn -- saame tiendada
            if last_star == V - 1: # kas see trn on viimases veerus?
                value = 0
                for v in range(V - 1):
                    value = value + table[r][v]
            else:
                value = table[r][V - 1]
                for v in range(V - 1):
                    if v != last_star:
                        value = value - table[r][v]
            table[r][last_star] = value
            modified = True
    # Nd vaatleme veerge
    for v in range(V):
        stars = 0
        last_star = None
        for r in range(R):
            if table[r][v] == '*':
                stars = stars + 1
                last_star = r
        if stars == 1: # ksainus trn -- saame tiendada
            if last_star == R - 1: # kas see trn on viimases reas?
                value = 0
                for r in range(R - 1):
                    value = value + table[r][v]
            else:
                value = table[R - 1][v]
                for r in range(R - 1):
                    if r != last_star:
                        value = value - table[r][v]
            table[last_star][v] = value
            modified = True

# Kui enam midagi tiendada ei ole, vljastame resultaadi
outfile = open('TBL.VAL', 'w')
for r in range(R):
    outfile.write(' '.join([str(word) for word in table[r]]) + '\n')
outfile.close()
